<?php



// urlから、JANコードを取得
$janCode = $_GET['janCode'];


// urlから線幅(1モジュールの幅)を取得
$lineWidth = $_GET['lineWidth'];

if ( $lineWidth == 0 ) {
  $lineWidth = 1;
}


// urlから線の長さ(高さ)を取得
$lineLength = $_GET['lineLength'];

if ( $lineLength == 0 ) {
  $lineLength = 32;
}


// urlから線の色を取得。未設定の場合は黒色
$lineColor = $_GET['lineColor'];

if ( $lineColor == '' ) {
  $lineColor = 'black';
}


// urlから背景色を取得。未設定の場合は白色
$backgroundColor = $_GET['backgroundColor'];
if ( $backgroundColor == '' ) {
  $backgroundColor = 'white';
}






// JANコードを左から1桁ずつ取り出して配列に格納する
for ($n = 1; $n < 14; $n++){
  $eachNumberOfJanCodeArray[$n] = substr($janCode, ($n-1), 1);
  
}


// チェックディジットの検証と追加

$checkDigit = 10 - ( ( ( $eachNumberOfJanCodeArray[2] + $eachNumberOfJanCodeArray[4] + $eachNumberOfJanCodeArray[6] + $eachNumberOfJanCodeArray[8] + $eachNumberOfJanCodeArray[10] + $eachNumberOfJanCodeArray[12] ) * 3 + $eachNumberOfJanCodeArray[1] + $eachNumberOfJanCodeArray[3] + $eachNumberOfJanCodeArray[5] + $eachNumberOfJanCodeArray[7] + $eachNumberOfJanCodeArray[9] + $eachNumberOfJanCodeArray[11] ) % 10 );


if ($checkDigit === 10) {
  $checkDigit = 0;
}


// チェックディジットがない場合は、計算したチェックディジットを使う
if ($eachNumberOfJanCodeArray[13] === '') {
  $eachNumberOfJanCodeArray[13] = $checkDigit;
}

// 計算されたチェックディジットと入力されたチェックディジットが違う場合は、線の色と背景色を赤色にして表示する
if ($eachNumberOfJanCodeArray[13] != $checkDigit) {
  $lineColor = 'red';
  $backgroundColor = 'red';
}










// JANの各数字の4分割比率
$ratio[0] = '3211';
$ratio[1] = '2221';
$ratio[2] = '2122';
$ratio[3] = '1411';
$ratio[4] = '1132';
$ratio[5] = '1231';
$ratio[6] = '1114';
$ratio[7] = '1312';
$ratio[8] = '1213';
$ratio[9] = '3112';


// JANの左1桁めの数字で決定される、左データ6文字分(左2桁目から左7桁目まで)のパリティの偶奇
// 0が偶数、1が奇数
$oddEven[0] = '111111';
$oddEven[1] = '110100';
$oddEven[2] = '110010';
$oddEven[3] = '110001';
$oddEven[4] = '101100';
$oddEven[5] = '100110';
$oddEven[6] = '100011';
$oddEven[7] = '101010';
$oddEven[8] = '101001';
$oddEven[9] = '100101';










// JANコードの各数字をバーで表現
function createBarCodeSegment($digitNumber, $xPosition) {
  
  
  
  
  global $ratio, $oddEven, $eachNumberOfJanCodeArray, $lineWidth, $lineLength, $lineColor;


  
  
  // JANコードの左1桁目の数字から、その桁のパリティの偶奇を求める(0が偶、1が奇)。そして各線の塗りつぶしの色を決める。
  
  if ($digitNumber >= 2 and $digitNumber <= 7) {
    $oddOrEven = substr($oddEven[($eachNumberOfJanCodeArray[1])], ($digitNumber-2), 1);
   
    $color1 = 'none';
    $color2 = $lineColor;
    
    if ($oddOrEven == 0) {
      // strrevは文字列を逆順にする
      $ratioOfThisDigit = strrev($ratio[$eachNumberOfJanCodeArray[$digitNumber]]);
    } else {
      $ratioOfThisDigit = $ratio[$eachNumberOfJanCodeArray[$digitNumber]];
    }
    
    
  }
  
  if ($digitNumber >= 8 and $digitNumber <= 13) {
    $oddOrEven = substr($oddEven[($eachNumberOfJanCodeArray[1])], ($digitNumber-2), 1);
    
    $color1 = $lineColor;
    $color2 = 'none';
    $ratioOfThisDigit = $ratio[$eachNumberOfJanCodeArray[$digitNumber]];

  }
  

// バーの線幅を算出する
$widthOfBar1 = $lineWidth * (substr($ratioOfThisDigit, 0, 1));
$widthOfBar2 = $lineWidth * (substr($ratioOfThisDigit, 1, 1));
$widthOfBar3 = $lineWidth * (substr($ratioOfThisDigit, 2, 1));
$widthOfBar4 = $lineWidth * (substr($ratioOfThisDigit, 3, 1));


// バーのx軸での位置を決める
$xPositionOfBar1 = $xPosition;
$xPositionOfBar2 = $xPositionOfBar1 + $widthOfBar1;
$xPositionOfBar3 = $xPositionOfBar2 + $widthOfBar2;
$xPositionOfBar4 = $xPositionOfBar3 + $widthOfBar3;
  
  
// SVGでバーを記述する  
echo '
    <rect fill="'.$color1.'" x="'.$xPositionOfBar1.'" width="'.$widthOfBar1.'" height="'.$lineLength.'"/>
    <rect fill="'.$color2.'" x="'.$xPositionOfBar2.'" width="'.$widthOfBar2.'" height="'.$lineLength.'"/>
    <rect fill="'.$color1.'" x="'.$xPositionOfBar3.'" width="'.$widthOfBar3.'" height="'.$lineLength.'"/>
    <rect fill="'.$color2.'" x="'.$xPositionOfBar4.'" width="'.$widthOfBar4.'" height="'.$lineLength.'"/>  
';
 
  
}




// バーコードの左右のマージンを作る
// 左側マージンは11個のバー(モジュール)、右側マージンは7個のバー(モジュール)
function createBarCodeMargin($widthOfMargin, $xPosition) {
  
  
  global $lineWidth, $lineLength;
  
  $pxWidthOfMargin = $widthOfMargin * $lineWidth;
  
  echo '
     <rect fill="none" x="'.$xPosition.'" width="'.$pxWidthOfMargin.'" height="'.$lineLength.'"/>  
  ';
  
}






// 左右にガードバーを作る
function createGuardBar($xPosition) {
  
  global $lineWidth, $lineLength, $lineColor;
  
  
  echo '
    <rect fill="'.$lineColor.'" x="'.$xPosition.'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>
    <rect fill="none" x="'.($xPosition + $lineWidth).'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>
    <rect fill="'.$lineColor.'" x="'.($xPosition + $lineWidth*2).'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>  
';




}









// センターバーを作る
function createCenterBar($xPosition) {
  
  global $lineWidth, $lineLength, $lineColor;
    
  
  echo '
    <rect fill="none"           x="'.($xPosition                 ).'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>
    <rect fill="'.$lineColor.'" x="'.($xPosition + $lineWidth * 1).'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>
    <rect fill="none"           x="'.($xPosition + $lineWidth * 2).'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>
    <rect fill="'.$lineColor.'" x="'.($xPosition + $lineWidth * 3).'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>
    <rect fill="none"           x="'.($xPosition + $lineWidth * 4).'" width="'.$lineWidth.'" height="'.($lineLength+5*$lineWidth).'"/>  
  ';



}








// ここからSVGの始まり
echo '<?xml version="1.0" encoding="UTF-8"?>
<svg xmlns="http://www.w3.org/2000/svg" width="'.(113*$lineWidth).'" height="'.($lineLength+11*$lineWidth).'" viewBox="0 0 '.(113*$lineWidth).' '.($lineLength+11*$lineWidth).'">
';


//背景を作る
echo '
    <rect fill="'.$backgroundColor.'" width="'.(113*$lineWidth).'" height="'.($lineLength+11*$lineWidth).'"/>
';




$xPosition = 0;

createBarCodeMargin(11, $xPosition);
$xPosition = $xPosition + $lineWidth*11;

createGuardBar($xPosition);
$xPosition = $xPosition + $lineWidth*3;

createBarCodeSegment(2, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(3, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(4, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(5, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(6, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(7, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createCenterBar($xPosition);
$xPosition = $xPosition + $lineWidth*5;

createBarCodeSegment(8, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(9, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(10, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(11, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(12, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createBarCodeSegment(13, $xPosition);
$xPosition = $xPosition + $lineWidth*7;

createGuardBar($xPosition);
$xPosition = $xPosition + $lineWidth*3;

createBarCodeMargin(7, $xPosition);








// ここよりJANの数字の表示




// 各数字の文字をアウトライン(SVGのパス)にして、配列に格納する。フォントはTuffy Regular 21ptでアウトラインをとった。Tuffyフォントはパブリックドメイン。
$numberPath[0]='<path fill="'.$lineColor.'" d="M7.14,2.13c2.35,0,3.89,2.1,4.49,4.94.19.91.3,1.9.3,2.91,0,4.18-1.76,7.75-4.88,7.75-2.38,0-3.96-2.09-4.56-4.95-.18-.87-.29-1.83-.29-2.8,0-4.2,1.84-7.85,4.94-7.85ZM4.09,12.6c.43,2,1.37,3.68,2.96,3.68,2.3,0,3.26-3.45,3.26-6.3,0-.91-.09-1.89-.29-2.79-.41-1.97-1.32-3.62-2.88-3.62-2.28,0-3.32,3.53-3.32,6.41,0,.85.08,1.76.27,2.61Z"/>';
$numberPath[1]='<path fill="'.$lineColor.'" d="M5.52,5.07l2.29-2.56h.94v14.93h-1.61V5.07h-1.62Z"/>';
$numberPath[2]='<path fill="'.$lineColor.'" d="M2.44,5.49c.52-1.88,2.5-3.38,4.57-3.38s4.31,1.38,4.31,4.53c0,2.88-3.08,4.54-4.07,5.25-1.06.76-3.07,2.74-3.07,4.1h7.41v1.45H2.29c0-3.34,2.31-5.41,4.47-6.93,1.1-.77,2.98-1.78,2.98-3.87s-1.37-3.09-2.74-3.09-2.62.84-3.15,2.5l-1.43-.56Z"/>';
$numberPath[3]='<path fill="'.$lineColor.'" d="M3.98,14.37c.52,1.14,1.74,1.91,2.86,1.91,1.83,0,3.4-1.19,3.4-3.19s-1.73-3.15-3.36-3.15h-.8v-1.28h1c1.28,0,2.46-1.1,2.46-2.67,0-1.4-1.22-2.48-2.48-2.48h-.06c-1.13,0-1.97.66-2.39,1.62l-1.4-.66c.71-1.4,2.13-2.39,3.86-2.39,2.06,0,4.1,1.58,4.1,3.91,0,1.8-1.18,2.94-1.88,3.29.98.3,2.56,1.76,2.56,3.8,0,2.71-2.2,4.65-5.01,4.65-1.6,0-3.66-1.04-4.45-2.88l1.59-.48Z"/>';
$numberPath[4]='<path fill="'.$lineColor.'" d="M10.04,11.93h1.94v1.44h-1.94v4.07h-1.61v-4.07H2.08L8.29,2.51h1.74v9.42ZM4.5,11.91h3.97v-6.99l-3.97,6.99Z"/>';
$numberPath[5]='<path fill="'.$lineColor.'" d="M4.7,10.15l-1.49-.77.96-6.87h6.89v1.45h-5.55l-.68,4.39c.59-.36,1.37-.56,2.52-.56,2.23,0,3.95,1.44,4.43,3.67.08.4.13.83.13,1.28,0,2.65-1.76,5-4.62,5-2.37,0-4.13-1.52-4.75-3.68l1.6-.29c.36,1.05,1.13,2.51,3.15,2.51,1.8,0,3.02-1.45,3.02-3.57,0-.3-.03-.58-.09-.85-.33-1.57-1.55-2.7-2.87-2.7-1.64,0-2.35.74-2.67.98Z"/>';
$numberPath[6]='<path fill="'.$lineColor.'" d="M7.05,8.64c2.21,0,4.11,1.53,4.56,3.65.07.31.1.64.1.96,0,2.12-1.83,4.48-4.69,4.48-2.36,0-4.03-1.7-4.44-3.61-.06-.29-.09-.59-.09-.89,0-2.09,1.24-3.83,1.72-4.72l3.42-5.99h1.59l-3.59,6.43c.46-.19.8-.32,1.4-.32ZM10.12,12.61c-.29-1.36-1.48-2.44-3.07-2.44-1.83,0-3.01,1.52-3.01,3.05,0,.23.02.44.06.65.3,1.4,1.55,2.34,2.97,2.34,1.9,0,3.12-1.49,3.12-2.94,0-.22-.03-.43-.07-.65Z"/>';
$numberPath[7]='<path fill="'.$lineColor.'" d="M6.55,17.44h-1.87l5.29-13.4H2.31v-1.53h9.93l-5.69,14.93Z"/>';
$numberPath[8]='<path fill="'.$lineColor.'" d="M11.3,5.12c.06.25.08.51.08.79,0,1.99-1.28,2.87-1.93,3.25.91.42,2.28,1.37,2.62,3.02.05.26.08.52.08.82,0,2.71-2.33,4.73-5.01,4.73-2.35,0-4.33-1.57-4.8-3.74-.06-.32-.1-.65-.1-.98,0-2.27,1.64-3.45,2.62-3.85-.65-.38-1.54-1.03-1.81-2.36-.06-.27-.09-.56-.09-.89,0-2.16,1.78-3.82,4.2-3.82,2.11,0,3.75,1.25,4.13,3.04ZM10.54,13.01c0-.24-.02-.46-.06-.68-.33-1.54-1.76-2.47-3.29-2.47-1.85,0-3.32,1.15-3.32,3.15,0,.24.03.47.07.7.33,1.52,1.67,2.57,3.21,2.57,1.87,0,3.39-1.47,3.39-3.27ZM4.64,6.52c.25,1.19,1.25,1.89,2.54,1.89,1.47,0,2.58-.9,2.58-2.49,0-.19-.02-.38-.06-.55-.23-1.07-1.12-1.83-2.54-1.83-1.68,0-2.58,1.08-2.58,2.38,0,.22.02.41.06.6Z"/>';
$numberPath[9]='<path fill="'.$lineColor.'" d="M7.31,11.26c-2.21,0-4.11-1.53-4.56-3.65-.06-.31-.1-.64-.1-.97,0-2.12,1.84-4.49,4.69-4.49,2.37,0,4.04,1.72,4.44,3.62.06.3.09.59.09.89,0,2.1-1.23,3.85-1.72,4.73l-3.32,6.05h-1.72l3.62-6.49c-.46.19-.8.32-1.4.32ZM4.25,7.3c.29,1.36,1.48,2.43,3.06,2.43,1.83,0,3.02-1.51,3.02-3.05,0-.22-.02-.43-.07-.64-.3-1.4-1.55-2.36-2.97-2.36-1.89,0-3.11,1.51-3.11,2.95,0,.23.02.44.07.66Z"/>';





// JANの数字をSVGで表示する
echo '<svg x="'.($lineWidth*2).'"                 y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[1])].'</svg>'."\n";

echo '<svg x="'.($lineWidth*7*2).'"               y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[2])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*3).'"               y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[3])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*4).'"               y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[4])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*5).'"               y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[5])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*6).'"               y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[6])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*7).'"               y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[7])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*8+$lineWidth*5).'"  y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[8])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*9+$lineWidth*5).'"  y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[9])].'</svg>'."\n";

echo '<svg x="'.($lineWidth*7*10+$lineWidth*5).'" y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[10])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*11+$lineWidth*5).'" y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[11])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*12+$lineWidth*5).'" y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[12])].'</svg>'."\n";
echo '<svg x="'.($lineWidth*7*13+$lineWidth*5).'" y="'.($lineLength+$lineWidth*1).'"  width="'.(7*$lineWidth).'"  height="'.(10*$lineWidth).'" viewBox="0 0 14 20">'.$numberPath[($eachNumberOfJanCodeArray[13])].'</svg>'."\n";




echo '</svg>';



?>
